diff --git a/salt/modules/virt.py b/salt/modules/virt.py
index c8e046a47a..a78c21e323 100644
--- a/salt/modules/virt.py
+++ b/salt/modules/virt.py
@@ -839,33 +1097,105 @@ def _qemu_image_create(disk, create_overlay=False, saltenv='base'):
             mask = salt.utils.files.get_umask()
 
             if disk_size:
-                log.debug('Create empty image with size %sM', disk_size)
-                __salt__['cmd.run'](
-                    'qemu-img create -f {0} "{1}" {2}M'
-                    .format(disk.get('format', 'qcow2'), img_dest, disk_size)
+                log.debug("Create empty image with size %sM", disk_size)
+                __salt__["cmd.run"](
+                    'qemu-img create -f {0} "{1}" {2}M'.format(
+                        disk.get("format", "qcow2"), img_dest, disk_size
+                    )
                 )
             else:
                 raise CommandExecutionError(
-                    'Unable to create new disk {0},'
-                    ' please specify <size> argument'
-                    .format(img_dest)
+                    "Unable to create new disk {0},"
+                    " please specify <size> argument".format(img_dest)
                 )
 
-            log.debug('Apply umask and remove exec bit')
+            log.debug("Apply umask and remove exec bit")
             mode = (0o0777 ^ mask) & 0o0666
             os.chmod(img_dest, mode)
 
         except (IOError, OSError) as err:
             raise CommandExecutionError(
-                'Problem while creating volume {0} - {1}'
-                .format(img_dest, err)
+                "Problem while creating volume {0} - {1}".format(img_dest, err)
             )
 
     return img_dest
 
 
-def _disk_profile(profile, hypervisor, disks=None, vm_name=None, image=None, pool=None, **kwargs):
-    '''
+def _seed_image(seed_cmd, img_path, name, config, install, pub_key, priv_key):
+    """
+    Helper function to seed an existing image. Note that this doesn't
+    handle volumes.
+    """
+    log.debug("Seeding image")
+    __salt__[seed_cmd](
+        img_path,
+        id_=name,
+        config=config,
+        install=install,
+        pub_key=pub_key,
+        priv_key=priv_key,
+    )
+
+
+def _disk_volume_create(conn, disk, seeder=None, saltenv="base"):
+    """
+    Create a disk volume for use in a VM
+    """
+    if disk.get("overlay_image"):
+        raise SaltInvocationError(
+            "Disk overlay_image property is not supported when creating volumes,"
+            "use backing_store_path and backing_store_format instead."
+        )
+
+    pool = conn.storagePoolLookupByName(disk["pool"])
+
+    # Use existing volume if possible
+    if disk["filename"] in pool.listVolumes():
+        return
+
+    pool_type = ElementTree.fromstring(pool.XMLDesc()).get("type")
+
+    backing_path = disk.get("backing_store_path")
+    backing_format = disk.get("backing_store_format")
+    backing_store = None
+    if (
+        backing_path
+        and backing_format
+        and (disk.get("format") == "qcow2" or pool_type == "logical")
+    ):
+        backing_store = {"path": backing_path, "format": backing_format}
+
+    if backing_store and disk.get("image"):
+        raise SaltInvocationError(
+            "Using a template image with a backing store is not possible, "
+            "choose either of them."
+        )
+
+    vol_xml = _gen_vol_xml(
+        disk["filename"],
+        disk.get("size", 0),
+        format=disk.get("format"),
+        backing_store=backing_store,
+    )
+    _define_vol_xml_str(conn, vol_xml, disk.get("pool"))
+
+    if disk.get("image"):
+        log.debug("Caching disk template image: %s", disk.get("image"))
+        cached_path = __salt__["cp.cache_file"](disk.get("image"), saltenv)
+
+        if seeder:
+            seeder(cached_path)
+        _volume_upload(
+            conn,
+            disk["pool"],
+            disk["filename"],
+            cached_path,
+            sparse=disk.get("format") == "qcow2",
+        )
+
+
+def _disk_profile(conn, profile, hypervisor, disks, vm_name):
+    """
     Gather the disk profile from the config or apply the default based
     on the active hypervisor
 
@@ -902,22 +1232,16 @@ def _disk_profile(profile, hypervisor, disks=None, vm_name=None, image=None, poo
 
     The ``format`` and ``model`` parameters are optional, and will
     default to whatever is best suitable for the active hypervisor.
-    '''
-    default = [{'system':
-                {'size': 8192}}]
-    if hypervisor == 'vmware':
-        overlay = {'format': 'vmdk',
-                   'model': 'scsi',
-                   'device': 'disk',
-                   'pool': '[{0}] '.format(pool if pool else '0')}
-    elif hypervisor in ['qemu', 'kvm']:
-        overlay = {'format': 'qcow2',
-                   'device': 'disk',
-                   'model': 'virtio'}
-    elif hypervisor == 'xen':
-        overlay = {'format': 'qcow2',
-                   'device': 'disk',
-                   'model': 'xen'}
+    """
+    default = [{"system": {"size": 8192}}]
+    if hypervisor == "vmware":
+        overlay = {"format": "vmdk", "model": "scsi", "device": "disk"}
+    elif hypervisor in ["qemu", "kvm"]:
+        overlay = {"device": "disk", "model": "virtio"}
+    elif hypervisor == "xen":
+        overlay = {"device": "disk", "model": "xen"}
+    elif hypervisor in ["bhyve"]:
+        overlay = {"format": "raw", "model": "virtio", "sparse_volume": False}
     else:
         overlay = {}
 
@@ -925,89 +1249,153 @@ def _disk_profile(profile, hypervisor, disks=None, vm_name=None, image=None, poo
     disklist = []
     if profile:
         disklist = copy.deepcopy(
-            __salt__['config.get']('virt:disk', {}).get(profile, default))
+            __salt__["config.get"]("virt:disk", {}).get(profile, default)
+        )
 
         # Transform the list to remove one level of dictionnary and add the name as a property
         disklist = [dict(d, name=name) for disk in disklist for name, d in disk.items()]
 
-        # Add the image to the first disk if there is one
-        if image:
-            # If image is specified in module arguments, then it will be used
-            # for the first disk instead of the image from the disk profile
-            log.debug('%s image from module arguments will be used for disk "%s"'
-                      ' instead of %s', image, disklist[0]['name'], disklist[0].get('image', ""))
-            disklist[0]['image'] = image
-
     # Merge with the user-provided disks definitions
     if disks:
         for udisk in disks:
-            if 'name' in udisk:
-                found = [disk for disk in disklist if udisk['name'] == disk['name']]
+            if "name" in udisk:
+                found = [disk for disk in disklist if udisk["name"] == disk["name"]]
                 if found:
                     found[0].update(udisk)
                 else:
                     disklist.append(udisk)
 
+    # Get pool capabilities once to get default format later
+    pool_caps = _pool_capabilities(conn)
+
     for disk in disklist:
+        # Set default model for cdrom devices before the overlay sets the wrong one
+        if disk.get("device", "disk") == "cdrom" and "model" not in disk:
+            disk["model"] = "ide"
+
         # Add the missing properties that have defaults
         for key, val in six.iteritems(overlay):
             if key not in disk:
                 disk[key] = val
 
         # We may have an already computed source_file (i.e. image not created by our module)
-        if 'source_file' in disk and disk['source_file']:
-            disk['filename'] = os.path.basename(disk['source_file'])
-        elif 'source_file' not in disk:
-            _fill_disk_filename(vm_name, disk, hypervisor, **kwargs)
+        if disk.get("source_file") and os.path.exists(disk["source_file"]):
+            disk["filename"] = os.path.basename(disk["source_file"])
+            if not disk.get("format"):
+                disk["format"] = (
+                    "qcow2" if disk.get("device", "disk") != "cdrom" else "raw"
+                )
+        elif disk.get("device", "disk") == "disk":
+            _fill_disk_filename(conn, vm_name, disk, hypervisor, pool_caps)
 
     return disklist
 
 
-def _fill_disk_filename(vm_name, disk, hypervisor, **kwargs):
-    '''
+def _fill_disk_filename(conn, vm_name, disk, hypervisor, pool_caps):
+    """
     Compute the disk file name and update it in the disk value.
-    '''
-    base_dir = disk.get('pool', None)
-    if hypervisor in ['qemu', 'kvm', 'xen']:
+    """
+    # Compute the filename without extension since it may not make sense for some pool types
+    disk["filename"] = "{0}_{1}".format(vm_name, disk["name"])
+
+    # Compute the source file path
+    base_dir = disk.get("pool", None)
+    if hypervisor in ["qemu", "kvm", "xen"]:
         # Compute the base directory from the pool property. We may have either a path
         # or a libvirt pool name there.
-        # If the pool is a known libvirt one with a target path, use it as target path
         if not base_dir:
             base_dir = _get_images_dir()
+
+        # If the pool is a known libvirt one, skip the filename since a libvirt volume will be created later
+        if base_dir not in conn.listStoragePools():
+            # For path-based disks, keep the qcow2 default format
+            if not disk.get("format"):
+                disk["format"] = "qcow2"
+            disk["filename"] = "{0}.{1}".format(disk["filename"], disk["format"])
+            disk["source_file"] = os.path.join(base_dir, disk["filename"])
         else:
-            if not base_dir.startswith('/'):
-                # The pool seems not to be a path, lookup for pool infos
-                infos = pool_info(base_dir, **kwargs)
-                pool = infos[base_dir] if base_dir in infos else None
-                if not pool or not pool['target_path'] or pool['target_path'].startswith('/dev'):
-                    raise CommandExecutionError(
-                                'Unable to create new disk {0}, specified pool {1} does not exist '
-                                'or is unsupported'.format(disk['name'], base_dir))
-                base_dir = pool['target_path']
+            if "pool" not in disk:
+                disk["pool"] = base_dir
+            pool_obj = conn.storagePoolLookupByName(base_dir)
+            pool_xml = ElementTree.fromstring(pool_obj.XMLDesc())
+            pool_type = pool_xml.get("type")
+
+            # Disk pools volume names are partition names, they need to be named based on the device name
+            if pool_type == "disk":
+                device = pool_xml.find("./source/device").get("path")
+                all_volumes = pool_obj.listVolumes()
+                if disk.get("source_file") not in all_volumes:
+                    indexes = [
+                        int(re.sub("[a-z]+", "", vol_name)) for vol_name in all_volumes
+                    ] or [0]
+                    index = min(
+                        [
+                            idx
+                            for idx in range(1, max(indexes) + 2)
+                            if idx not in indexes
+                        ]
+                    )
+                    disk["filename"] = "{}{}".format(os.path.basename(device), index)
+
+            # Is the user wanting to reuse an existing volume?
+            if disk.get("source_file"):
+                if not disk.get("source_file") in pool_obj.listVolumes():
+                    raise SaltInvocationError(
+                        "{} volume doesn't exist in pool {}".format(
+                            disk.get("source_file"), base_dir
+                        )
+                    )
+                disk["filename"] = disk["source_file"]
+                del disk["source_file"]
+
+            # Get the default format from the pool capabilities
+            if not disk.get("format"):
+                volume_options = (
+                    [
+                        type_caps.get("options", {}).get("volume", {})
+                        for type_caps in pool_caps.get("pool_types")
+                        if type_caps["name"] == pool_type
+                    ]
+                    or [{}]
+                )[0]
+                # Still prefer qcow2 if possible
+                if "qcow2" in volume_options.get("targetFormatType", []):
+                    disk["format"] = "qcow2"
+                else:
+                    disk["format"] = volume_options.get("default_format", None)
 
-    # Compute the filename and source file properties if possible
-    if vm_name:
-        disk['filename'] = '{0}_{1}.{2}'.format(vm_name, disk['name'], disk['format'])
-        disk['source_file'] = os.path.join(base_dir, disk['filename'])
+    elif hypervisor == "bhyve" and vm_name:
+        disk["filename"] = "{0}.{1}".format(vm_name, disk["name"])
+        disk["source_file"] = os.path.join(
+            "/dev/zvol", base_dir or "", disk["filename"]
+        )
+
+    elif hypervisor in ["esxi", "vmware"]:
+        if not base_dir:
+            base_dir = __salt__["config.get"]("virt:storagepool", "[0] ")
+        disk["filename"] = "{0}.{1}".format(disk["filename"], disk["format"])
+        disk["source_file"] = "{0}{1}".format(base_dir, disk["filename"])
 
 
-def _complete_nics(interfaces, hypervisor, dmac=None):
-    '''
+def _complete_nics(interfaces, hypervisor):
+    """
     Complete missing data for network interfaces.
-    '''
+    """
 
-    vmware_overlay = {'type': 'bridge', 'source': 'DEFAULT', 'model': 'e1000'}
-    kvm_overlay = {'type': 'bridge', 'source': 'br0', 'model': 'virtio'}
-    xen_overlay = {'type': 'bridge', 'source': 'br0', 'model': None}
+    vmware_overlay = {"type": "bridge", "source": "DEFAULT", "model": "e1000"}
+    kvm_overlay = {"type": "bridge", "source": "br0", "model": "virtio"}
+    xen_overlay = {"type": "bridge", "source": "br0", "model": None}
+    bhyve_overlay = {"type": "bridge", "source": "bridge0", "model": "virtio"}
     overlays = {
-            'xen': xen_overlay,
-            'kvm': kvm_overlay,
-            'qemu': kvm_overlay,
-            'vmware': vmware_overlay,
-            }
+        "xen": xen_overlay,
+        "kvm": kvm_overlay,
+        "qemu": kvm_overlay,
+        "vmware": vmware_overlay,
+        "bhyve": bhyve_overlay,
+    }
 
     def _normalize_net_types(attributes):
-        '''
+        """
         Guess which style of definition:
 
             bridge: br0
@@ -1020,84 +1408,49 @@ def _complete_nics(interfaces, hypervisor, dmac=None):
 
             type: network
             source: net0
-        '''
-        for type_ in ['bridge', 'network']:
+        """
+        for type_ in ["bridge", "network"]:
             if type_ in attributes:
-                attributes['type'] = type_
+                attributes["type"] = type_
                 # we want to discard the original key
-                attributes['source'] = attributes.pop(type_)
+                attributes["source"] = attributes.pop(type_)
 
-        attributes['type'] = attributes.get('type', None)
-        attributes['source'] = attributes.get('source', None)
+        attributes["type"] = attributes.get("type", None)
+        attributes["source"] = attributes.get("source", None)
 
     def _apply_default_overlay(attributes):
-        '''
+        """
         Apply the default overlay to attributes
-        '''
+        """
         for key, value in six.iteritems(overlays[hypervisor]):
             if key not in attributes or not attributes[key]:
                 attributes[key] = value
 
-    def _assign_mac(attributes, hypervisor):
-        '''
-        Compute mac address for NIC depending on hypervisor
-        '''
-        if dmac is not None:
-            log.debug('Default MAC address is %s', dmac)
-            if salt.utils.validate.net.mac(dmac):
-                attributes['mac'] = dmac
-            else:
-                msg = 'Malformed MAC address: {0}'.format(dmac)
-                raise CommandExecutionError(msg)
-        else:
-            if hypervisor in ['qemu', 'kvm']:
-                attributes['mac'] = salt.utils.network.gen_mac(
-                    prefix='52:54:00')
-            else:
-                attributes['mac'] = salt.utils.network.gen_mac()
-
     for interface in interfaces:
         _normalize_net_types(interface)
-        if interface.get('mac', None) is None:
-            _assign_mac(interface, hypervisor)
         if hypervisor in overlays:
             _apply_default_overlay(interface)
 
     return interfaces
 
 
-def _nic_profile(profile_name, hypervisor, dmac=None):
-    '''
+def _nic_profile(profile_name, hypervisor):
+    """
     Compute NIC data based on profile
-    '''
-
-    default = [{'eth0': {}}]
-
-    # support old location
-    config_data = __salt__['config.option']('virt.nic', {}).get(
-        profile_name, None
+    """
+    config_data = __salt__["config.get"]("virt:nic", {}).get(
+        profile_name, [{"eth0": {}}]
     )
 
-    if config_data is not None:
-        salt.utils.versions.warn_until(
-            'Sodium',
-            '\'virt.nic\' has been deprecated in favor of \'virt:nic\'. '
-            '\'virt.nic\' will stop being used in {version}.'
-        )
-    else:
-        config_data = __salt__['config.get']('virt:nic', {}).get(
-            profile_name, default
-        )
-
     interfaces = []
 
     # pylint: disable=invalid-name
     def append_dict_profile_to_interface_list(profile_dict):
-        '''
+        """
         Append dictionary profile data to interfaces list
-        '''
+        """
         for interface_name, attributes in six.iteritems(profile_dict):
-            attributes['name'] = interface_name
+            attributes["name"] = interface_name
             interfaces.append(attributes)
 
     # old style dicts (top-level dicts)
@@ -1134,25 +1487,24 @@ def _nic_profile(profile_name, hypervisor, dmac=None):
                 else:
                     interfaces.append(interface)
 
-    # dmac can only be used from init()
-    return _complete_nics(interfaces, hypervisor, dmac=dmac)
+    return _complete_nics(interfaces, hypervisor)
 
 
-def _get_merged_nics(hypervisor, profile, interfaces=None, dmac=None):
-    '''
+def _get_merged_nics(hypervisor, profile, interfaces=None):
+    """
     Get network devices from the profile and merge uer defined ones with them.
-    '''
-    nicp = _nic_profile(profile, hypervisor, dmac=dmac) if profile else []
-    log.debug('NIC profile is %s', nicp)
+    """
+    nicp = _nic_profile(profile, hypervisor) if profile else []
+    log.debug("NIC profile is %s", nicp)
     if interfaces:
         users_nics = _complete_nics(interfaces, hypervisor)
         for unic in users_nics:
-            found = [nic for nic in nicp if nic['name'] == unic['name']]
+            found = [nic for nic in nicp if nic["name"] == unic["name"]]
             if found:
                 found[0].update(unic)
             else:
                 nicp.append(unic)
-        log.debug('Merged NICs: %s', nicp)
+        log.debug("Merged NICs: %s", nicp)
     return nicp
 
 
@@ -1168,62 +1520,60 @@ def _handle_remote_boot_params(orig_boot):
     """
     saltinst_dir = None
     new_boot = orig_boot.copy()
+    keys = orig_boot.keys()
+    cases = [
+        {"loader", "nvram"},
+        {"kernel", "initrd"},
+        {"kernel", "initrd", "cmdline"},
+        {"loader", "nvram", "kernel", "initrd"},
+        {"loader", "nvram", "kernel", "initrd", "cmdline"},
+    ]
 
     try:
-        for key in ['kernel', 'initrd']:
-            if check_remote(orig_boot.get(key)):
-                if saltinst_dir is None:
-                    os.makedirs(CACHE_DIR)
-                    saltinst_dir = CACHE_DIR
-
-                new_boot[key] = download_remote(orig_boot.get(key),
-                                                saltinst_dir)
-
-        return new_boot
+        if keys in cases:
+            for key in keys:
+                if orig_boot.get(key) is not None and check_remote(orig_boot.get(key)):
+                    if saltinst_dir is None:
+                        os.makedirs(CACHE_DIR)
+                        saltinst_dir = CACHE_DIR
+                    new_boot[key] = download_remote(orig_boot.get(key), saltinst_dir)
+            return new_boot
+        else:
+            raise SaltInvocationError(
+                "Invalid boot parameters, (kernel, initrd) or/and (loader, nvram) must be both present"
+            )
     except Exception as err:  # pylint: disable=broad-except
         raise err
 
 
-def init(name,
-         cpu,
-         mem,
-         image=None,
-         nic='default',
-         interfaces=None,
-         hypervisor=None,
-         start=True,  # pylint: disable=redefined-outer-name
-         disk='default',
-         disks=None,
-         saltenv='base',
-         seed=True,
-         install=True,
-         pub_key=None,
-         priv_key=None,
-         seed_cmd='seed.apply',
-         enable_vnc=False,
-         enable_qcow=False,
-         graphics=None,
-         os_type=None,
-         arch=None,
-         boot=None,
-         **kwargs):
-    '''
+def init(
+    name,
+    cpu,
+    mem,
+    nic="default",
+    interfaces=None,
+    hypervisor=None,
+    start=True,  # pylint: disable=redefined-outer-name
+    disk="default",
+    disks=None,
+    saltenv="base",
+    seed=True,
+    install=True,
+    pub_key=None,
+    priv_key=None,
+    seed_cmd="seed.apply",
+    graphics=None,
+    os_type=None,
+    arch=None,
+    boot=None,
+    **kwargs
+):
+    """
     Initialize a new vm
 
     :param name: name of the virtual machine to create
     :param cpu: Number of virtual CPUs to assign to the virtual machine
     :param mem: Amount of memory to allocate to the virtual machine in MiB.
-    :param image: Path to a disk image to use as the first disk (Default: ``None``).
-                  Deprecated in favor of the ``disks`` parameter. To set (or change) the image of a
-                  disk, add the following to the disks definitions:
-
-                  .. code-block:: python
-
-                      {
-                          'name': 'name_of_disk_to_change',
-                          'image': '/path/to/the/image'
-                      }
-
     :param nic: NIC profile to use (Default: ``'default'``).
                 The profile interfaces can be customized / extended with the interfaces parameter.
                 If set to ``None``, no profile will be used.
@@ -1250,17 +1600,6 @@ def init(name,
     :param pub_key: public key to seed with (Default: ``None``)
     :param priv_key: public key to seed with (Default: ``None``)
     :param seed_cmd: Salt command to execute to seed the image. (Default: ``'seed.apply'``)
-    :param enable_vnc:
-        ``True`` to setup a vnc display for the VM (Default: ``False``)
-
-        Deprecated in favor of the ``graphics`` parameter. Could be replaced with
-        the following:
-
-        .. code-block:: python
-
-            graphics={'type': 'vnc'}
-
-        .. deprecated:: 2019.2.0
     :param graphics:
         Dictionary providing details on the graphics device to create. (Default: ``None``)
         See :ref:`init-graphics-def` for more details on the possible values.
@@ -1276,51 +1615,6 @@ def init(name,
         but ``x86_64`` is prefed over ``i686``.
 
         .. versionadded:: 2019.2.0
-    :param enable_qcow:
-        ``True`` to create a QCOW2 overlay image, rather than copying the image
-        (Default: ``False``).
-
-        Deprecated in favor of ``disks`` parameter. Add the following to the disks
-        definitions to create an overlay image of a template disk image with an
-        image set:
-
-        .. code-block:: python
-
-            {
-                'name': 'name_of_disk_to_change',
-                'overlay_image': True
-            }
-
-        .. deprecated:: 2019.2.0
-    :param pool:
-        Path of the folder where the image files are located for vmware/esx hypervisors.
-
-        Deprecated in favor of ``disks`` parameter. Add the following to the disks
-        definitions to set the vmware datastore of a disk image:
-
-        .. code-block:: python
-
-            {
-                'name': 'name_of_disk_to_change',
-                'pool': 'mydatastore'
-            }
-
-        .. deprecated:: Flurorine
-    :param dmac:
-        Default MAC address to use for the network interfaces. By default MAC addresses are
-        automatically generated.
-
-        Deprecated in favor of ``interfaces`` parameter. Add the following to the interfaces
-        definitions to force the mac address of a NIC:
-
-        .. code-block:: python
-
-            {
-                'name': 'name_of_nic_to_change',
-                'mac': 'MY:MA:CC:ADD:RE:SS'
-            }
-
-        .. deprecated:: 2019.2.0
     :param config: minion configuration to use when seeding.
                    See :mod:`seed module for more details <salt.modules.seed>`
     :param boot_dev: String of space-separated devices to boot from (Default: ``'hd'``)
@@ -1337,21 +1631,48 @@ def init(name,
 
                      .. versionadded:: 2019.2.0
     :param boot:
-        Specifies kernel for the virtual machine, as well as boot parameters
-        for the virtual machine. This is an optionl parameter, and all of the
-        keys are optional within the dictionary. If a remote path is provided
-        to kernel or initrd, salt will handle the downloading of the specified
-        remote fild, and will modify the XML accordingly.
+        Specifies kernel, initial ramdisk and kernel command line parameters for the virtual machine.
+        This is an optional parameter, all of the keys are optional within the dictionary. The structure of
+        the dictionary is documented in :ref:`init-boot-def`. If a remote path is provided to kernel or initrd,
+        salt will handle the downloading of the specified remote file and modify the XML accordingly.
+        To boot VM with UEFI, specify loader and nvram path.
+
+        .. versionadded:: 3000
 
         .. code-block:: python
 
             {
                 'kernel': '/root/f8-i386-vmlinuz',
                 'initrd': '/root/f8-i386-initrd',
-                'cmdline': 'console=ttyS0 ks=http://example.com/f8-i386/os/'
+                'cmdline': 'console=ttyS0 ks=http://example.com/f8-i386/os/',
+                'loader': '/usr/share/OVMF/OVMF_CODE.fd',
+                'nvram': '/usr/share/OVMF/OVMF_VARS.ms.fd'
             }
 
-        .. versionadded:: 3000
+    .. _init-boot-def:
+
+    .. rubric:: Boot parameters definition
+
+    The boot parameters dictionary can contains the following properties:
+
+    kernel
+        The URL or path to the kernel to run the virtual machine with.
+
+    initrd
+        The URL or path to the initrd file to run the virtual machine with.
+
+    cmdline
+        The parameters to pass to the kernel provided in the `kernel` property.
+
+    loader
+        The path to the UEFI binary loader to use.
+
+        .. versionadded:: sodium
+
+    nvram
+        The path to the UEFI data template. The file will be copied when creating the virtual machine.
+
+        .. versionadded:: sodium
 
     .. _init-nic-def:
 
@@ -1393,7 +1714,12 @@ def init(name,
 
     pool
         Path to the folder or name of the pool where disks should be created.
-        (Default: depends on hypervisor)
+        (Default: depends on hypervisor and the virt:storagepool configuration)
+
+        .. versionchanged:: sodium
+
+        If the value contains no '/', it is considered a pool name where to create a volume.
+        Using volumes will be mandatory for some pools types like rdb, iscsi, etc.
 
     model
         One of the disk busses allowed by libvirt (Default: depends on hypervisor)
@@ -1404,19 +1730,69 @@ def init(name,
         Path to the image to use for the disk. If no image is provided, an empty disk will be created
         (Default: ``None``)
 
+        Note that some pool types do not support uploading an image. This list can evolve with libvirt
+        versions.
+
     overlay_image
         ``True`` to create a QCOW2 disk image with ``image`` as backing file. If ``False``
         the file pointed to by the ``image`` property will simply be copied. (Default: ``False``)
 
+        .. versionchanged:: sodium
+
+        This property is only valid on path-based disks, not on volumes. To create a volume with a
+        backing store, set the ``backing_store_path`` and ``backing_store_format`` properties.
+
+    backing_store_path
+        Path to the backing store image to use. This can also be the name of a volume to use as
+        backing store within the same pool.
+
+        .. versionadded:: sodium
+
+    backing_store_format
+        Image format of the disk or volume to use as backing store. This property is mandatory when
+        using ``backing_store_path`` to avoid `problems <https://libvirt.org/kbase/backing_chains.html#troubleshooting>`_
+
+        .. versionadded:: sodium
+
     source_file
         Absolute path to the disk image to use. Not to be confused with ``image`` parameter. This
         parameter is useful to use disk images that are created outside of this module. Can also
         be ``None`` for devices that have no associated image like cdroms.
 
+        .. versionchanged:: sodium
+
+        For volume disks, this can be the name of a volume already existing in the storage pool.
+
     device
         Type of device of the disk. Can be one of 'disk', 'cdrom', 'floppy' or 'lun'.
         (Default: ``'disk'``)
 
+    hostname_property
+        When using ZFS volumes, setting this value to a ZFS property ID will make Salt store the name of the
+        virtual machine inside this property. (Default: ``None``)
+
+    sparse_volume
+        Boolean to specify whether to use a thin provisioned ZFS volume.
+
+        Example profile for a bhyve VM with two ZFS disks. The first is
+        cloned from the specified image. The second disk is a thin
+        provisioned volume.
+
+        .. code-block:: yaml
+
+            virt:
+              disk:
+                two_zvols:
+                  - system:
+                      image: zroot/bhyve/CentOS-7-x86_64-v1@v1.0.5
+                      hostname_property: virt:hostname
+                      pool: zroot/bhyve/guests
+                  - data:
+                      pool: tank/disks
+                      size: 20G
+                      hostname_property: virt:hostname
+                      sparse_volume: True
+
     .. _init-graphics-def:
 
     .. rubric:: Graphics Definition
